/*
	Robota's Jumper
	http://www.robota.net
	Version 1.0
	Released the 19-01-2004
*/

#include "jumper.h"

#define version "1.2"
#define release "23-01-2004"

int flags = RESOLV_F;

char network[16];
pcap_t *pc;

void fin(int s) {

    pcap_close(pc);
  
    informe(network,flags);

    exit(0);  
}

void banner() {
    fprintf(stdout,"\n[+] ROBOTA Jumper %s (%s)\n", version,release);
    fprintf(stdout,"[+] http://www.robota.net\n\n");
}

void ethernet(u_char *u, const struct pcap_pkthdr *h, const u_char *d) {
    struct ether_header *eth;
    struct libnet_arp_hdr *arp;
    unsigned char host_ip[17], host_mac[13];
   
    char errbuf[LIBNET_ERRBUF_SIZE];
    libnet_t *l;

    eth = (struct ether_header*)d;
    arp = (struct libnet_arp_hdr*)(d + ETH_HLEN);

    if (ntohs(eth->ether_type) == ETHERTYPE_ARP) {
	switch(htons(arp->ar_op)){
	    case 2:
		sprintf(host_ip,"%d.%d.%d.%d",
			*(d+ETH_HLEN+ARP_H_LEN+6),
			*(d+ETH_HLEN+ARP_H_LEN+7),
			*(d+ETH_HLEN+ARP_H_LEN+8),
			*(d+ETH_HLEN+ARP_H_LEN+9));
			
		sprintf(host_mac,"%c%c%c%c%c%c",
			*(d+ETH_HLEN+ARP_H_LEN+0),
			*(d+ETH_HLEN+ARP_H_LEN+1),
			*(d+ETH_HLEN+ARP_H_LEN+2),
			*(d+ETH_HLEN+ARP_H_LEN+3),
			*(d+ETH_HLEN+ARP_H_LEN+4),
			*(d+ETH_HLEN+ARP_H_LEN+5));

			l = libnet_init(LIBNET_RAW4, NULL, errbuf);

			if (l == NULL) {
				fprintf(stderr, "[!] Libnet error failed: %s", errbuf);
				exit(EXIT_FAILURE);
			}
			addnethost( host_mac, (libnet_name2addr4(l, (char *)host_ip, 1)) );
			libnet_destroy(l);
			break;
	}
    }
}

void usage(char *s) {
    fprintf(stdout,"Usage: %s -i <Interface> -n [Network] -f -d\n\n", s);
    fprintf(stdout,"-i      -> Ethernet interface to scan\n");
    fprintf(stdout,"-n      -> Network to scan (Default: Your own network)\n");
    fprintf(stdout,"-f      -> Create an nmap script\n");
    fprintf(stdout,"-d      -> Don't resolve the hostnames\n\n");

    fprintf(stdout,"Examples ->\n");
    fprintf(stdout,"To scan your own network on interface eth0 ->\n %s -i eth0\n\n", s);
    fprintf(stdout,"To scan the network 172.16.0.0 ->\n %s -i eth0 -n 172.16.0.0\n\n",s);
    fprintf(stdout,"To scan your own network and create the nmap script 'Robota.sh' ->\n %s -i eth0 -f\n\n",s);

    exit(-1);
}

int main(int argc, char **argv) {
    pcap_handler rutina;
    char *dev = NULL;
    bpf_u_int32 red, mascara;
    char ebuf[PCAP_ERRBUF_SIZE];
    int c, datalink, perfidnet = 0;

    char errbuf[LIBNET_ERRBUF_SIZE];
    libnet_t *l;

    banner();

    while ((c = getopt(argc, argv, "n:i:df")) != -1)
    {
	switch(c)
	{
		case 'i':
			dev=optarg;
			break;
		case 'd':
			flags &= ~(RESOLV_F);
			break;
		case 'f':
			flags |= SCRIPT_F;       
			break;
		case 'n':
			l = libnet_init(LIBNET_RAW4, NULL, errbuf);
			red=libnet_name2addr4(l,optarg,0);
			perfidnet=1;
			libnet_destroy(l);
			break;
	}
    }

    if(dev==NULL) usage(argv[0]);

    if(getuid()>0) {
	fprintf(stdout,"[!] You must be root to run this tool\n\n");
	exit(-1);
    }

    fprintf(stdout, "[+] Device: %s\n",dev);

    if (!(pc = pcap_open_live(dev, ETHER_MAX_LEN, 1, 0, ebuf))) {
	fprintf(stderr, "[!] Error: %s\n\n", ebuf);
	exit(-1);
    }

    if ((datalink = pcap_datalink(pc)) < 0) {
	fprintf(stderr, "pcap_datalink: %s\n", pcap_geterr(pc));
	exit(-1);
    }

    switch(datalink) {
	case DLT_EN10MB:

	    if(perfidnet==0) 
		pcap_lookupnet(dev, &red, &mascara, ebuf);
	
	    sprintf(network,"%d.%d.%d.%d",
		(red&0x000000FF),
		((red&0x0000FF00)>>8),
		((red&0x00FF0000)>>16),
		((red&0xFF000000)>>24));

	    fprintf(stdout,"[+] Network: %s\n", network);

	    fprintf(stdout, "[+] Level 2: Ethernet\n");
	    rutina = ethernet;
	    fprintf(stdout, "[+] Sending ARP Requests ... ");
	    arpstorm(dev, red);
	    fprintf(stdout, "Done\n");
	    fprintf(stdout, "\n[+] Press CTRL+C to stop collecting replies\n"); 
	    fprintf(stdout, "    and print the results\n");
	    break;

	default:
	    fprintf(stderr, "[!] Error: (%i) I can't manage the interface %s\n\n", datalink, dev);
	    exit(1);
    }

    signal(SIGINT, fin);
    pcap_loop(pc, -1, rutina, NULL);

    return(1); 

}
